package drones.geo;

import java.util.Objects;

/**
 * Represents a tube station
 *
 * @author John Ahlroos
 */
public record TubeStation(Point point, String name) {

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        TubeStation that = (TubeStation) o;
        return Objects.equals(name, that.name);
    }

    @Override
    public int hashCode() {
        return Objects.hash(name);
    }

    @Override
    public String toString() {
        return String.format("(name=%s, lat=%f, lon=%f)", name, point.latitude(), point.longitude());
    }
}
