package drones.messages;

import drones.geo.Point;
import org.junit.jupiter.api.Test;

import java.time.LocalDateTime;
import java.util.ArrayList;

import static org.junit.jupiter.api.Assertions.assertEquals;

public class EventBusTest {

    @Test
    public void listenerTriggeredOnEvent() {
        var triggered = new ArrayList<Message>();
        var eventBus = new EventBus(0);
        eventBus.register(triggered::add);

        eventBus.push(new Message.PointData(1L, new Point(1, 2, LocalDateTime.now())));
        eventBus.push(new Message.ShutdownSignal(2, 2, LocalDateTime.now()));

        assertEquals(2, triggered.size());
        assertEquals(1, triggered.get(0).targetId());
        assertEquals(2, triggered.get(1).targetId());
    }
}
