package simulation.logging;

import ch.qos.logback.classic.spi.ILoggingEvent;
import ch.qos.logback.core.sift.AbstractDiscriminator;

/**
 * Provides capability for the logger to log drone logs to different files
 *
 * @author John Ahlroos
 */
public class DroneLogPerFile extends AbstractDiscriminator<ILoggingEvent> {
    @Override
    public String getDiscriminatingValue(ILoggingEvent event) {
        return event.getLoggerName().split("\\.")[1];
    }

    @Override
    public String getKey() {
        return "droneId";
    }
}
